Bug 2903 - (int-126302) Uninstalling/Removing in-use theme plus reboot causes missing graphics
: Uninstalling/Removing in-use theme plus reboot causes missing graphics
Product: Desktop platform
: 5.0-beta2
: All Linux
: Low normal with 2 votes (vote)
: 5.0 (1.2009.41-10)
Assigned To: unassigned
: themes-bugs
  Show dependency tree
Reported: 2008-02-07 00:06 UTC by Leif Ryge
Modified: 2009-08-13 12:30 UTC (History)
1 user (show)

See Also:

Screenshot of Modest after removing in-use theme (39.98 KB, image/png)
2008-11-04 19:09 UTC, Andre Klapper


You need to log in before you can comment on or make changes to this bug.

Description Leif Ryge (reporter) 2008-02-07 00:06:18 UTC
OS2008 versions 1.2007.44 and 2.2007.50

1. Install a theme (such as Plankton or LCARS)
2. Switch to that theme
3. Remove the (currently in use) theme using the Application manager
4. Try to switch to a different theme
5. Reboot

1. After removing the currently selected theme, it should be possible to switch
back to another theme
2. Rebooting with the currently selected theme missing should cause the system
to revert to the default theme

1. Unable to switch themes (until currently selected theme is reinstalled)
2. Rebooting with a missing theme selected causes an endless reboot loop

Outcome #1 verified repeatedly, outcome #2 was only tested once


Removing the currently-in-use theme is not something that ever actually needs
to be done, but it is something that could very easily be done by accident...
which seems to cause the user's device to become unusable until a reflash
(unless they reinstall the theme before they reboot).
Comment 1 Urho Konttori 2008-03-24 19:04:27 UTC
This should be fixed in the theme prerm packages. Any good idea on how to check
if theme is currently in use? It should be trivial to add it to prerm when
someone documents how that check should be done.
Comment 2 Leif Ryge (reporter) 2008-07-27 04:30:54 UTC
I noticed that in diablo there is a new validate_theme() function in
/etc/osso-af-init/osso-gtk.defs which appears to detect this condition and
revert to the default theme, but I have not yet tested to see if it actually
works because I don't want to reflash if it doesn't.

Can someone from Nokia confirm that this is fixed in diablo?
Comment 3 Leif Ryge (reporter) 2008-08-29 00:48:01 UTC
I can confirm that this is (mostly) fixed in diablo; at least, the reboot loop
no longer occurs.

Now, after the in-use theme is removed, the system appears to be rather broken
(missing graphics in some places) and it is still impossible to switch themes
in this state. As of diablo, however, after rebooting with a missing theme
selected, the default theme is restored and I am able to switch themes again.

Would it be possible for something like hildon-desktop or sapwood-server to
watch the currently-in-use index.theme file so that when it is removed the
system will switch back to the default theme immediately?
Comment 4 Andre Klapper maemo.org 2008-11-04 19:08:43 UTC
1. Set theme to LCARS Bridge.
2. Rebooted to have it fully applied (there's already a bug report about this).
3. Started Application manager.
4. Show installed apps
5. Choose hildon-theme-lcars-bridge and click Uninstall
6. "Successfully uninstalled" message

No reboot loop.
Partially broken interfaces, missing translation strings etc. See screenshot.
I cannot change the theme - clicking on "Echo" or "Glasser" tells me "Theme
already in use".

Everything works fine again.
Comment 5 Andre Klapper maemo.org 2008-11-04 19:09:42 UTC
Created an attachment (id=1029) [details]
Screenshot of Modest after removing in-use theme
Comment 6 Andre Klapper maemo.org 2009-03-26 18:51:04 UTC
I wonder if this can be already tested with the Fremantle alpha SDK, but
probably that's too early.
It's most likely a WONTFIX for Diablo as it's not critical enough.
Comment 7 Andre Klapper maemo.org 2009-05-31 16:56:53 UTC
So the reboot issue has been fixed, and the remaining issue (images not
correctly applied before rebooting) is basically bug 3659.
Hence closing.
Comment 8 Andre Klapper maemo.org 2009-07-02 16:01:11 UTC
This is back again in Fremantle.
Comment 9 Andre Klapper maemo.org 2009-08-04 15:34:52 UTC
This issue has been FIXED in the internal Fremantle version.

This is a WONTFIX for Diablo as Diablo is in maintenance mode and Nokia will
only provide bugfixes for critical issues if at all.
For your interest the Mer project aims to provide a community backport of
Fremantle for N8x0 devices. See http://wiki.maemo.org/Mer for more information.
Comment 10 Andre Klapper maemo.org 2009-08-13 12:30:12 UTC
(Note to myself: Also see int-129270)